package WebFlow.JobService; 
import WebFlow.*; 
import WebFlow.event.*; 
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 

public class Client{

public static String XmlInput;
public static String RSL;
public static String InstallRSL;

   public static void main(String args[])
   {
      configReader config ; 

      try
      {
         //  Create ORB
         ORB orb = ORB.init(args , new java.util.Properties()); 

         //  Connect to the master server

         String masterURL = args[0] ; 
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
      
         System.out.println(" masterURL : "+masterURL); 

         ref = getIORFromURL(masterURL); 

         System.out.println("REF: "+ref); 

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 

         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 
         
          org.omg.CORBA.Object p1 = ws.addNewModule("JobServer"); 
          JobServer server = JobServerHelper.narrow(p1);   

          org.omg.CORBA.Object p2 = ws.addNewModule("JobDescriptor");
          JobDescriptor job = JobDescriptorHelper.narrow(p2);

          XmlInput = "C:\\Gateway\\BeanContext_2.2.1\\xml\\TestAppl.xml"; 


      
          server.setApplication(job,XmlInput,"aga.npac.syr.edu","MyTest");
          System.out.println(server.installApplication("MyTest"));
          server.setParameter("MyTest","param1","ucho");
          System.out.println(server.getParameter("MyTest","param1"));
            String[] params = server.getAllParamNames("MyTest");
            for(int i=0; i<params.length; i++) {
                      System.out.println(params[i]+" = "
                      +server.getParameter("MyTest",params[i]));
	    }
            String jobid = server.submitJob("MyTest");
          server.getStatus(jobid);

      } catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex); 

        System.err.println(ex.getMessage()); 
        ex.printStackTrace(); 
        System.exit(1); 
       }  
   }       

   static public String getIORFromURL(String url) {

   System.out.println("Slave WebFlow is getting IOR from url:"+url); 
   String masterServerIOR =""; 
   String thisLine = null ; 

   // Open the URL for reading 
 
   try{
        URL u = new URL(url); 

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){ 
             masterServerIOR += thisLine ; 
          } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
     }
    return masterServerIOR ; 
  }
}
